<template>
  <div class="text-center">
    <img
      v-if="preview"
      :src="preview"
      style="max-width: 100%; max-height: 200px"
    />
    <v-file-input
      v-model="files"
      accept="image/*, video/*"
      :label="label"
      v-bind="$attrs"
      ref="file"
      @change="change(files)"
      @click:clear="clear"
    ></v-file-input>
  </div>
</template>

<script>
export default {
  inheritAttrs: false,
  name: "UploadInput",
  props: {
    endpoint: {
      type: String,
      default: ""
    },
    label: {
      type: String,
      default: ""
    },
    value: {
      type: String,
      default: ""
    },
    instantupload: {
      type: Boolean,
      default: false
    },
    type: {
      type: String,
      default: "image"
    }
  },
  data() {
    return {
      files: [],
      preview: "",
      dirty: false,
      isNewlyUploaded: false
    };
  },
  computed: {
    computedValue: {
      get() {
        return this.value;
      },
      set(v) {
        this.$emit("input", v);
      }
    }
  },
  watch: {
    async value(v) {
      if (!v) {
        this.reset();
      }
      if (this.isNewlyUploaded) {
        this.isNewlyUploaded = false;
        return;
      }
      this.init(v);
    }
  },
  async created() {
    this.init(this.value);
  },
  methods: {
    clear() {
      this.$emit("input", null);
    },
    async process() {
      if (!this.dirty) {
        return;
      }
      const formData = new FormData();
      formData.append("file", this.files);
      try {
        const response = await this.$axios.post(
          this.endpoint + "?type=" + this.type,
          formData,
          {
            headers: {
              "Content-Type": "multipart/form-data"
            }
          }
        );
        const data = { ...response.data };
        this.isNewlyUploaded = true;
        this.computedValue = data.id;
      } catch (e) {
        return new Error(e);
      }
    },
    change(file) {
      this.dirty = true;
      this.generatePreview(file);
    },
    generatePreview(file) {
      if (file && file instanceof File) {
        this.preview = URL.createObjectURL(file);
      } else {
        this.preview = "";
      }
    },
    reset() {
      this.file = [];
      this.dirty = false;
      this.preview = "";
    },
    async init(v) {
      if (!this.value) {
        return;
      }
      try {
        const response = await this.$axios.get(`${this.endpoint}/${v}`, {
          responseType: "blob"
        });
        const blob = new Blob([response.data]);
        const file = new File([blob], v);
        this.generatePreview(file);
        this.files = file;
      } catch (e) {
        this.$emit("initError");
      }
    }
  }
};
</script>
